# coding: utf-8

"""
    Allegro REST API

    https://developer.allegro.pl/about  # noqa: E501

    The version of the OpenAPI document: 2020.01.28
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from allegro_api.configuration import Configuration


class DeliverySettingsDtoJoinPolicy(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'strategy': 'str'
    }

    attribute_map = {
        'strategy': 'strategy'
    }

    def __init__(self, strategy=None, local_vars_configuration=None):  # noqa: E501
        """DeliverySettingsDtoJoinPolicy - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._strategy = None
        self.discriminator = None

        if strategy is not None:
            self.strategy = strategy

    @property
    def strategy(self):
        """Gets the strategy of this DeliverySettingsDtoJoinPolicy.  # noqa: E501

        Strategy used to calculate delivery cost for items from offers with different delivery costs. The possible values:   * `MAX` - The buyer will pay for the most expensive delivery   * `MIN` - The buyer will pay for the cheapest delivery   * `SUM` - Items will be sent in separate parcels and delivery costs will be sum of delivery costs for each item.  # noqa: E501

        :return: The strategy of this DeliverySettingsDtoJoinPolicy.  # noqa: E501
        :rtype: str
        """
        return self._strategy

    @strategy.setter
    def strategy(self, strategy):
        """Sets the strategy of this DeliverySettingsDtoJoinPolicy.

        Strategy used to calculate delivery cost for items from offers with different delivery costs. The possible values:   * `MAX` - The buyer will pay for the most expensive delivery   * `MIN` - The buyer will pay for the cheapest delivery   * `SUM` - Items will be sent in separate parcels and delivery costs will be sum of delivery costs for each item.  # noqa: E501

        :param strategy: The strategy of this DeliverySettingsDtoJoinPolicy.  # noqa: E501
        :type: str
        """
        allowed_values = ["MIN", "MAX", "SUM"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and strategy not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `strategy` ({0}), must be one of {1}"  # noqa: E501
                .format(strategy, allowed_values)
            )

        self._strategy = strategy

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeliverySettingsDtoJoinPolicy):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DeliverySettingsDtoJoinPolicy):
            return True

        return self.to_dict() != other.to_dict()
