# coding: utf-8

"""
    Allegro REST API

    https://developer.allegro.pl/about  # noqa: E501

    The version of the OpenAPI document: 2020.01.28
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from allegro_api.configuration import Configuration


class OfferEventEndedOfferAllOfPublication(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'ended_by': 'str'
    }

    attribute_map = {
        'ended_by': 'endedBy'
    }

    def __init__(self, ended_by=None, local_vars_configuration=None):  # noqa: E501
        """OfferEventEndedOfferAllOfPublication - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._ended_by = None
        self.discriminator = None

        self.ended_by = ended_by

    @property
    def ended_by(self):
        """Gets the ended_by of this OfferEventEndedOfferAllOfPublication.  # noqa: E501

        Indicates the reason for ending the offer:  - `USER` - offer ended by the seller.  - `ADMIN` - offer ended by an admin.  - `EXPIRATION` - offer ended because all available items had been sold out or offer duration had expired (valid for    offers with specified duration).  - `ERROR` - offer ended due to internal problem with offer publication. The publication command responded with    success status, but further processing failed.  - `UNKNOWN` - in rare cases the reason might be unknown.  # noqa: E501

        :return: The ended_by of this OfferEventEndedOfferAllOfPublication.  # noqa: E501
        :rtype: str
        """
        return self._ended_by

    @ended_by.setter
    def ended_by(self, ended_by):
        """Sets the ended_by of this OfferEventEndedOfferAllOfPublication.

        Indicates the reason for ending the offer:  - `USER` - offer ended by the seller.  - `ADMIN` - offer ended by an admin.  - `EXPIRATION` - offer ended because all available items had been sold out or offer duration had expired (valid for    offers with specified duration).  - `ERROR` - offer ended due to internal problem with offer publication. The publication command responded with    success status, but further processing failed.  - `UNKNOWN` - in rare cases the reason might be unknown.  # noqa: E501

        :param ended_by: The ended_by of this OfferEventEndedOfferAllOfPublication.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and ended_by is None:  # noqa: E501
            raise ValueError("Invalid value for `ended_by`, must not be `None`")  # noqa: E501
        allowed_values = ["USER", "ADMIN", "EXPIRATION", "ERROR", "UNKNOWN"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and ended_by not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `ended_by` ({0}), must be one of {1}"  # noqa: E501
                .format(ended_by, allowed_values)
            )

        self._ended_by = ended_by

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OfferEventEndedOfferAllOfPublication):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OfferEventEndedOfferAllOfPublication):
            return True

        return self.to_dict() != other.to_dict()
