# coding: utf-8

"""
    Allegro REST API

    https://developer.allegro.pl/about  # noqa: E501

    The version of the OpenAPI document: 2020.01.28
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from allegro_api.configuration import Configuration


class SellerOfferBaseEvent(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'occurred_at': 'datetime',
        'type': 'str'
    }

    attribute_map = {
        'id': 'id',
        'occurred_at': 'occurredAt',
        'type': 'type'
    }

    discriminator_value_class_map = {
        'OfferStockChangedEvent': 'OfferStockChangedEvent',
        'OfferPriceChangedEvent': 'OfferPriceChangedEvent',
        'OfferEndedEvent': 'OfferEndedEvent',
        'OfferBidPlacedEvent': 'OfferBidPlacedEvent',
        'OfferArchivedEvent': 'OfferArchivedEvent',
        'OfferBidCanceledEvent': 'OfferBidCanceledEvent',
        'OfferChangedEvent': 'OfferChangedEvent',
        'OfferActivatedEvent': 'OfferActivatedEvent'
    }

    def __init__(self, id=None, occurred_at=None, type=None, local_vars_configuration=None):  # noqa: E501
        """SellerOfferBaseEvent - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._occurred_at = None
        self._type = None
        self.discriminator = 'type'

        self.id = id
        self.occurred_at = occurred_at
        self.type = type

    @property
    def id(self):
        """Gets the id of this SellerOfferBaseEvent.  # noqa: E501

        The ID of the event. It can be used in the `from` parameter of the query.  # noqa: E501

        :return: The id of this SellerOfferBaseEvent.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this SellerOfferBaseEvent.

        The ID of the event. It can be used in the `from` parameter of the query.  # noqa: E501

        :param id: The id of this SellerOfferBaseEvent.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                id is not None and len(id) > 256):
            raise ValueError("Invalid value for `id`, length must be less than or equal to `256`")  # noqa: E501

        self._id = id

    @property
    def occurred_at(self):
        """Gets the occurred_at of this SellerOfferBaseEvent.  # noqa: E501

        The date and time when the event occurred, provided in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format.  # noqa: E501

        :return: The occurred_at of this SellerOfferBaseEvent.  # noqa: E501
        :rtype: datetime
        """
        return self._occurred_at

    @occurred_at.setter
    def occurred_at(self, occurred_at):
        """Sets the occurred_at of this SellerOfferBaseEvent.

        The date and time when the event occurred, provided in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format.  # noqa: E501

        :param occurred_at: The occurred_at of this SellerOfferBaseEvent.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and occurred_at is None:  # noqa: E501
            raise ValueError("Invalid value for `occurred_at`, must not be `None`")  # noqa: E501

        self._occurred_at = occurred_at

    @property
    def type(self):
        """Gets the type of this SellerOfferBaseEvent.  # noqa: E501

        The type of the event.  # noqa: E501

        :return: The type of this SellerOfferBaseEvent.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this SellerOfferBaseEvent.

        The type of the event.  # noqa: E501

        :param type: The type of this SellerOfferBaseEvent.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and type is None:  # noqa: E501
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    def get_real_child_model(self, data):
        """Returns the real base class specified by the discriminator"""
        discriminator_key = self.attribute_map[self.discriminator]
        discriminator_value = data[discriminator_key]
        return self.discriminator_value_class_map.get(discriminator_value)

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SellerOfferBaseEvent):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SellerOfferBaseEvent):
            return True

        return self.to_dict() != other.to_dict()
