# coding: utf-8

"""
    Allegro REST API

    https://developer.allegro.pl/about  # noqa: E501

    The version of the OpenAPI document: 2020.01.28
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from allegro_api.configuration import Configuration


class Wallet(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'payment_operator': 'str',
        'type': 'str',
        'balance': 'WalletBalance'
    }

    attribute_map = {
        'payment_operator': 'paymentOperator',
        'type': 'type',
        'balance': 'balance'
    }

    def __init__(self, payment_operator=None, type=None, balance=None, local_vars_configuration=None):  # noqa: E501
        """Wallet - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._payment_operator = None
        self._type = None
        self._balance = None
        self.discriminator = None

        self.payment_operator = payment_operator
        self.type = type
        self.balance = balance

    @property
    def payment_operator(self):
        """Gets the payment_operator of this Wallet.  # noqa: E501

        The payment operator.  # noqa: E501

        :return: The payment_operator of this Wallet.  # noqa: E501
        :rtype: str
        """
        return self._payment_operator

    @payment_operator.setter
    def payment_operator(self, payment_operator):
        """Sets the payment_operator of this Wallet.

        The payment operator.  # noqa: E501

        :param payment_operator: The payment_operator of this Wallet.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and payment_operator is None:  # noqa: E501
            raise ValueError("Invalid value for `payment_operator`, must not be `None`")  # noqa: E501
        allowed_values = ["PAYU", "P24"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and payment_operator not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `payment_operator` ({0}), must be one of {1}"  # noqa: E501
                .format(payment_operator, allowed_values)
            )

        self._payment_operator = payment_operator

    @property
    def type(self):
        """Gets the type of this Wallet.  # noqa: E501

        The type of the wallet.  # noqa: E501

        :return: The type of this Wallet.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Wallet.

        The type of the wallet.  # noqa: E501

        :param type: The type of this Wallet.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and type is None:  # noqa: E501
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501
        allowed_values = ["AVAILABLE", "WAITING"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and type not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def balance(self):
        """Gets the balance of this Wallet.  # noqa: E501


        :return: The balance of this Wallet.  # noqa: E501
        :rtype: WalletBalance
        """
        return self._balance

    @balance.setter
    def balance(self, balance):
        """Sets the balance of this Wallet.


        :param balance: The balance of this Wallet.  # noqa: E501
        :type: WalletBalance
        """
        if self.local_vars_configuration.client_side_validation and balance is None:  # noqa: E501
            raise ValueError("Invalid value for `balance`, must not be `None`")  # noqa: E501

        self._balance = balance

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Wallet):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Wallet):
            return True

        return self.to_dict() != other.to_dict()
